com.fasterxml.jackson.databind.type

## Class IterationType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.SimpleType
        - - com.fasterxml.jackson.databind.type.IterationType

All Implemented Interfaces:
  JsonSerializable, Serializable, Type

    public class IterationType
    extends SimpleType

Specialized `SimpleType` for types that are allow iteration over Collection(-like) types: this includes types like `Iterator`. Iterated (content) type is accessible using `getContentType()`.

Since:
  2.16
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

`JsonSerializable.Base`

### Field Summary

Fields
`protected JavaType` `_iteratedType`

### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bindings, _superClass, _superInterfaces`

### Fields inherited from class com.fasterxml.jackson.databind.JavaType

`_asStatic, _class, _hash, _typeHandler, _valueHandler`

### Constructor Summary

Constructors
`protected` `IterationType(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType iteratedType, Object valueHandler, Object typeHandler, boolean asStatic)`
`protected` `IterationType(TypeBase base, JavaType iteratedType)` Constructor used when upgrading into this type (via `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)`, the usual way for `IterationType`s to come into existence.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected String` `buildCanonicalName()`
`static IterationType` `construct(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType iteratedType)`
`JavaType` `getContentType()`
`StringBuilder` `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` `getGenericSignature(StringBuilder sb)`
`boolean` `hasContentType()` Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not.
`boolean` `isIterationType()` Method that returns true if this instance is of type `IterationType`.
`JavaType` `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
`static IterationType` `upgradeFrom(JavaType baseType, JavaType iteratedType)` Factory method that can be used to "upgrade" a basic type into iteration type; usually done via `TypeModifier`
`JavaType` `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
`IterationType` `withContentTypeHandler(Object h)` Internal method that should not be used by any code outside of jackson-databind: only used internally by databind.
`IterationType` `withContentValueHandler(Object h)` Internal method that should not be used by any code outside of jackson-databind: only used internally by databind.
`IterationType` `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
`IterationType` `withTypeHandler(Object h)` Internal method that should not be used by any code outside of jackson-databind: only used internally by databind.
`IterationType` `withValueHandler(Object h)` Internal method that should not be used by any code outside of jackson-databind: only used internally by databind.

### Methods inherited from class com.fasterxml.jackson.databind.type.SimpleType

`construct, constructUnsafe, equals, isContainerType, toString`

### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bogusSuperClass, _classSignature, _hasNTypeParameters, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

### Methods inherited from class com.fasterxml.jackson.databind.JavaType

`_narrow, containedTypeOrUnknown, forcedNarrowBy, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasGenericTypes, hasHandlers, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumImplType, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isRecordType, isThrowable, isTypeOrSubTypeOf, isTypeOrSuperTypeOf, useStaticType, withHandlersFrom`

### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

`isReferenceType`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.reflect.Type

`getTypeName`

### Field Detail

#### _iteratedType

    protected final JavaType _iteratedType

### Constructor Detail

#### IterationType

    protected IterationType(Class<?> cls,
                            TypeBindings bindings,
                            JavaType superClass,
                            JavaType[] superInts,
                            JavaType iteratedType,
                            Object valueHandler,
                            Object typeHandler,
                            boolean asStatic)

#### IterationType

    protected IterationType(TypeBase base,
                            JavaType iteratedType)

Constructor used when upgrading into this type (via `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)`, the usual way for `IterationType`s to come into existence. Sets up what is considered the "base" iteration type

### Method Detail

#### upgradeFrom

    public static IterationType upgradeFrom(JavaType baseType,
                                            JavaType iteratedType)

Factory method that can be used to "upgrade" a basic type into iteration type; usually done via `TypeModifier`

Parameters:
  `baseType` - Resolved non-iteration type (usually `SimpleType`) that is being upgraded
  `iteratedType` - Iterated type; usually the first and only type parameter, but not necessarily

#### construct

    public static IterationType construct(Class<?> cls,
                                          TypeBindings bindings,
                                          JavaType superClass,
                                          JavaType[] superInts,
                                          JavaType iteratedType)

#### withContentType

    public JavaType withContentType(JavaType contentType)

Description copied from class: `JavaType`
Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.

Overrides:
  `withContentType` in class `SimpleType`
Returns:
  Newly created type instance

#### withTypeHandler

    public IterationType withTypeHandler(Object h)

Description copied from class: `JavaType`
Internal method that should not be used by any code outside of jackson-databind: only used internally by databind. May be removed from Jackson 3.0.

This mutant factory method will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

Overrides:
  `withTypeHandler` in class `SimpleType`
Parameters:
  `h` - Handler to pass to new instance created
Returns:
  Newly created type instance with same type information, specified handler

#### withContentTypeHandler

    public IterationType withContentTypeHandler(Object h)

Description copied from class: `JavaType`
Internal method that should not be used by any code outside of jackson-databind: only used internally by databind. May be removed from Jackson 3.0.

This mutant factory method will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.

Overrides:
  `withContentTypeHandler` in class `SimpleType`
Parameters:
  `h` - Handler to pass to new instance created
Returns:
  Newly created type instance with same type information, specified handler

#### withValueHandler

    public IterationType withValueHandler(Object h)

Description copied from class: `JavaType`
Internal method that should not be used by any code outside of jackson-databind: only used internally by databind. May be removed from Jackson 3.0.

This mutant factory method will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Overrides:
  `withValueHandler` in class `SimpleType`
Parameters:
  `h` - Handler to pass to new instance created
Returns:
  Newly created type instance with same type information, specified handler

#### withContentValueHandler

    public IterationType withContentValueHandler(Object h)

Description copied from class: `JavaType`
Internal method that should not be used by any code outside of jackson-databind: only used internally by databind. May be removed from Jackson 3.0.

Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

Overrides:
  `withContentValueHandler` in class `SimpleType`
Parameters:
  `h` - Handler to pass to new instance created
Returns:
  Newly created type instance with same type information, specified handler

#### withStaticTyping

    public IterationType withStaticTyping()

Description copied from class: `JavaType`
Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).

Overrides:
  `withStaticTyping` in class `SimpleType`

#### refine

    public JavaType refine(Class<?> rawType,
                           TypeBindings bindings,
                           JavaType superClass,
                           JavaType[] superInterfaces)

Description copied from class: `JavaType`
Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.

Overrides:
  `refine` in class `SimpleType`

#### buildCanonicalName

    protected String buildCanonicalName()

Overrides:
  `buildCanonicalName` in class `SimpleType`

#### getContentType

    public JavaType getContentType()

Overrides:
  `getContentType` in class `JavaType`

#### hasContentType

    public boolean hasContentType()

Description copied from class: `JavaType`
Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not. True if `JavaType.isContainerType()` or `ResolvedType.isReferenceType()` return true.

Overrides:
  `hasContentType` in class `SimpleType`

#### isIterationType

    public boolean isIterationType()

Description copied from class: `JavaType`
Method that returns true if this instance is of type `IterationType`.

Overrides:
  `isIterationType` in class `JavaType`
Returns:
  True if this type is considered "iteration type"

#### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

Description copied from class: `JavaType`
Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

Overrides:
  `getErasedSignature` in class `SimpleType`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

Overrides:
  `getGenericSignature` in class `SimpleType`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining